<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="流水号" prop="standNo">
        <el-input v-model="formData.standNo" placeholder="请输入流水号" />
      </el-form-item>
      <el-form-item label="名称" prop="standName">
        <el-input v-model="formData.standName" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="状态" prop="state">
        <el-select v-model="formData.state" placeholder="请选择状态">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.EFFECTIVE_STATUS)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>      </el-form-item>
<!--      <el-form-item label="排序" prop="sort">
        <el-input v-model="formData.sort" placeholder="请输入排序" />
      </el-form-item>-->
    </el-form>
    <!-- 子表的表单 -->
    <el-tabs v-model="subTabsName">
      <el-tab-pane label="设备巡检标准内容" name="inspectionStandardItem">
        <InspectionStandardItemForm ref="inspectionStandardItemFormRef" :stand-id="formData.id" />
      </el-tab-pane>
    </el-tabs>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { InspectionStandardApi, InspectionStandard } from '@/api/device/inspectionstandard'
import InspectionStandardItemForm from './components/InspectionStandardItemForm.vue'
import {getIntDictOptions} from "@/utils/dict";
import { DICT_TYPE } from '@/utils/dict'

/** 设备巡检标准 表单 */
defineOptions({ name: 'InspectionStandardForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  standNo: undefined,
  standName: undefined,
  state: undefined,
  sort: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 子表的表单 */
const subTabsName = ref('inspectionStandardItem')
const inspectionStandardItemFormRef = ref()

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await InspectionStandardApi.getInspectionStandard(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 校验子表单
  try {
    await inspectionStandardItemFormRef.value.validate()
  } catch (e) {
    subTabsName.value = 'inspectionStandardItem'
    return
  }
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as InspectionStandard
    // 拼接子表的数据
    data.inspectionStandardItems = inspectionStandardItemFormRef.value.getData()
    if (formType.value === 'create') {
      await InspectionStandardApi.createInspectionStandard(data)
      message.success(t('common.createSuccess'))
    } else {
      await InspectionStandardApi.updateInspectionStandard(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    standNo: undefined,
    standName: undefined,
    state: undefined,
    sort: undefined,
  }
  formRef.value?.resetFields()
}
</script>
